# -*- coding: utf-8 -*-
import os
import requests
from bs4 import BeautifulSoup #bs4 pour BeautifulSoup4
#import pickle
#import string
import re
import pandas as pd

###########################################

# FONCTIONS : 

def get_links_reviews(url,plist): 
    res = [] # sera une liste de liens
    base_wos = "https://www.whatsonstage.com"
    # On parcourt toutes les pages : 
    for k in plist: 
        print(k)
        r = requests.get(url+'&page='+str(k))
        x = BeautifulSoup(r.text,'html.parser')
        # On recupere tous les clocs de la page : 
        blocks_page = x.find_all('a',
                                 attrs={'class':'styled__CssContentLinkImage-sc-2vb2mr-4 eOcXLp'})
        for i in range(len(blocks_page)):
            l = blocks_page[i].get('href')
            res.append(base_wos+l)
    return res    

def get_title_stageplay(s):
    t = s.find('meta',{'property':"og:title"})
    if t==None: 
        return None
    else: 
        t = t.get('content')
        res = t.split(sep='(')[0]
        res = res.replace('Review: ','')
        return res

def get_place_stageplay(s):
    t = s.find('meta',{'property':"og:title"})
    if t==None: 
        return None
    else: 
        t = t.get('content')
        res = t.split(sep='|')[0].split(sep='(')[-1]
        res = res.replace(')','')
        return res

def get_author_review(s):
    a = s.find('span',{'itemprop':"author"})
    res = re.sub('<[^>]+>','',str(a))
    return res

def get_date_review(s):
    x = s.find('time',{'itemprop':"datePublished"})
    if x==None: 
        return None
    else: 
        return x.get('datetime')

def get_rating_review(s):
    a = s.find('meta',{'property' : "reviewRating"})
    if a==None: 
        return None
    else: 
        return a.get('content')

def get_review(s): 
    x = s.find('div',{'itemprop':'articleBody'})
    if x==None: 
        return None
    else: 
        l = x.find_all('p')
        res = "".join(str(l))
        res = re.sub('<[^>]+>','',res)
        res = res.replace('[','')
        res = res.replace(']','')
        return res

# Remarque : pas de stockage precis pour les dates de debut et fin de show
# ni pour l'auteur / le metteur en scene de la piece. 

###########################################

url_wos = "https://www.whatsonstage.com/news/?categories=reviews"
list_pages_wos = list(range(1,417))
links_wos = get_links_reviews(url_wos,list_pages_wos)

# Save the list of links into a text file :
text_file = open("links_wos.txt","wt")
t = ""
for k in range(len(links_wos)): 
    t = t+links_wos[k]+"\n"
n = text_file.write(t)
text_file.close()

newspaper = ["WHAT'S ON STAGE"]*len(links_wos)
title = []
author = [None]*len(links_wos)
reviewer = []
review = []
director = [None]*len(links_wos)
opening = [None]*len(links_wos)
closing = [None]*len(links_wos)
date = []
place = []
rating = []

title = title[:9549]
reviewer = reviewer[:9549]
review = review[:9549]
date = date[:9549]
place = place[:9549]
rating = rating[:9549]
author = [None]*9549
director = [None]*9549
opening = [None]*9549
closing = [None]*9549
newspaper = ["WHAT'S ON STAGE"]*9549

k = 9549
for u in links_wos[9549:]: 
    print(k)
    r = requests.get(u)
    s = BeautifulSoup(r.text,'html.parser')
    title.append(get_title_stageplay(s))
    reviewer.append(get_author_review(s))
    review.append(get_review(s))
    date.append(get_date_review(s))
    place.append(get_place_stageplay(s))
    rating.append(get_rating_review(s))
    k = k+1

# Creer un dataframe et le stocker : 
df_wos = pd.DataFrame({'Newspaper':newspaper,
                      'Date':date,
                      'Reviewer':reviewer,
                      'Title':title,
                      'Author':author,
                      'Place':place,
                      'Opening':opening,
                      'Closing':closing,
                      'Director':director,
                      'Review':review,
                      'Rating':rating})

df_wos.to_csv('20201001_df_whatsonstage.csv',na_rep='NA')