import requests
from bs4 import BeautifulSoup #bs4 pour BeautifulSoup4
import pickle
import string

# On procede en 2 temps. Le premier est de recuperer les liens des pages ou se
# trouve le texte. Pour ceci il va falloir aller sur chacune des 240 pages
# Dans un deuxieme temps, on prendra le texte des pages ou l'on est alle.

###############################
###############################
########## Partie I ###########


# On commence par une analyse d'une page :

# On va chercher la page
r = requests.get("https://www.westendwilma.com/category/reviews/plays/")

# 0n a bien le code source :
print(r.text[0:100])

# Ici, on cherche à rendre le texte compréhensible par BeautifulSoup. 
soup = BeautifulSoup (r.text, 'html.parser')

# On peut remarquer que le block qui nous interesse est une liste (ul) de class
# block2. Dans cette liste se trouve tout ce dont on a besoin.
# On commence par verifier qu'un seul block correspond :
len(soup.find_all('ul', attrs = {'class' : "block2"})) # ok

# maintenant on garde ce block
block = soup.find('ul', attrs = {'class' : "block2"})

# On a donc garde que la partie qui nous interesse :
print(block)
len(block)

# Maintenant il s'agit de trouver les liens vers les autres pages
liste = block.find_all({'p'})
len(liste) # nombre de liens

# on initialise la liste ou seront stockes les liens
liens = []

for i in liste :
    x = BeautifulSoup (str(i), 'html.parser')
    liens.append(x.find('a').get('href'))

# C'est tout bon !!
print(liens)

# On fait une fonction pour faire ces etapes automatiquement
# sur une page donnee :

def recup_liens (path) :
    
    liens = []
    r = requests.get(path)

    soup = BeautifulSoup (r.text, 'html.parser')
    
    block = soup.find('ul', attrs = {'class' : "block2"})

    liste = block.find_all({'p'})
    
    for i in liste :
        x = BeautifulSoup (str(i), 'html.parser')
        liens.append(x.find('a').get('href'))

    return(liens)


# On verifie :
liens_test = recup_liens ('https://www.westendwilma.com/category/reviews/plays/page/2/')
print(liens_test)
# C'est encore bon


# Maintenant on recupere les liens de toutes les pages
liens_grande_liste = []

# On commence par ajouter les liens trouves sur la premiere page :
liens_grande_liste += liens


# Puis on itere. L'algo prend une quizaine de minutes car le site est lent.

for i in range(2,242):
    # on ajoute les liens :
    liens_grande_liste += recup_liens('https://www.westendwilma.com/category/reviews/plays/page/' + str(i) + '/')
    # on affiche i pour voir l'avancement de l'algo
    print(i)


# On regarde cb on a de liens :
print(len(liens_grande_liste))

# On verifie qu'il n'y a pas de bug
print(liens_grande_liste)

# C'est good !!! On enregistre


# Et on peut passer a la deuxieme partie :


###############################
###############################
######### Partie II ###########

liens_grande_liste = pickle.load(open('liens_scraping_mylene', 'rb'))

# On fait comme pour la partie I, on analyse une premiere page choisie au hasard
r = requests.get(liens_grande_liste[200])

soup = BeautifulSoup (r.text, 'html.parser')

# On recupere la date
date = soup.find('meta', {'property' : "article:published_time"}).get('content')

# On a trop d'infos, on s'interesse qu'au jour
print(date)

date = date[0:10]

# On regarde le titre
title = soup.find('meta', {'property' : "og:title"}).get('content')

# Il est trop long donc on garde que ce qui nous interesse
title = title.split("(")[0].split(" ")[1:]

title.remove("")

# On ajoute la date
title += [date]

title = '_'.join(title)

# Ca nous donne :
print(title)

block = soup.find('div', {'class' : "main-content "})

block.find_all('p')

raw_text = block.text.split('______')[0]

# On ne garde que le texte qui nous interesse :

text = raw_text[raw_text.find('R'):]

# On fait deux choses a la fois ici : on cree un fichier texte localise, et on ecrit dedans
open(title+'.txt','w', encoding="utf-8").write(text)

# Il ne reste plus qu'a automatiser :

def get_and_write_text (path):
    
    r = requests.get(path)
    
    soup = BeautifulSoup (r.text, 'html.parser')
    
    date = soup.find('meta', {'property' : "article:published_time"}).get('content')

    date = date[0:10]
    
    file_name = soup.find('meta', {'property' : "og:title"}).get('content')
    
    file_name = file_name.split("(")[0].split(" ")
    
    if "" in file_name:
        file_name.remove("")
    
    for i in range(len(file_name)) :
        
        file_name[i] = ''.join([str(e) for e in file_name[i] if e.isalnum()])
    
    file_name += [date]
    
    file_name = '_'.join(file_name)

    block = soup.find('div', {'class' : "main-content "})
    
    block.find_all('p')
    
    raw_text = block.text.split('______')[0]
    
    text = file_name + '\n' + raw_text[raw_text.find('R'):]

    open('fichier_bis/' + file_name + '.txt','w', encoding="utf-8").write(text)



get_and_write_text (liens_grande_liste[910])





